---
gitea: none
include_toc: true
---

# [PerfSPEC Learning Phase](README.md) Learning Phase -  INTRO

> [!IMPORTANT]
> A safety environment / service requires a persistent self-initiative behaviours toward a better understanding about what we have, where we are and what could probably will happen
> Sometimes is called **PROACTIVE mode**, a kind of alert state in the midst of chaos when everything is constantly evolving

Based in [PerfSPEC: Performance Profiling-based Proactive Security Policy Enforcement for Containers](https://ieeexplore.ieee.org/document/10577533) document presented in [1], this repository contains source files used to generate and process data.

For more [PerfSPEC](README.md) info use: 

- [Main description](README.md) 
- [Introduction](intro.md) 
- [Reference document](PerfSPEC.pdf)
- [Presentación in Spanish](presentacion.pdf)
- [How to install](https://repo.jesusperez.pro/jesus/perfspec-learning/src/branch/main/install.md)
- [Autogenerated graph view of actions and events distribution](actions_distribution.pdf)

<div style="margin: auto">
 <a target="_blank" href="perfspec-learning/src/branch/main/presentacion.pdf"><img src="imgs/perfSPEC-learning.png" width="800"></a>
</div>

# Why ?

Security has to be in **PROACTIVE mode** most of the time rather than constantly being living under threats or work most of the time in <i>postmortem</u> and forensic analisys 
constantly being living under threats

[PerfSPEC: Performance Profiling-based Proactive Security Policy Enforcement for Containers](https://ieeexplore.ieee.org/document/10577533) was designed to work in cloud/container security, one of the core processes or computing today and in the future, where distributed systems promise unprecedented resilience, scalability and performance.

Be safe has complex requirements, it is a constant and never ending exercise mix and match multiple elements that must be combined to create a peaceful way of life like the one of an orchestra and its musicians playing in front of an audience.

## PerfSPEC Schema 

How it would *play* could looks like this 

<div style="margin: auto">
 <a target="_blank" href="perfspec-learning/src/branch/main/presentacion.pdf"><img src="imgs/perfSPEC.png" width="800"></a>
</div>

## Reference

[1]: [H. Kermabon-Bobinnec et al., "PerfSPEC: Performance Profiling-based Proactive Security Policy Enforcement for Containers," in IEEE Transactions on Dependable and Secure Computing, doi: 10.1109/TDSC.2024.3420712.](https://ieeexplore.ieee.org/document/10577533)
